import { DependencyList, Reducer, IFiber, Dispatch, SetStateAction, EffectCallback, RefObject, FreNode } from "./type";
export declare const resetCursor: () => void;
export declare const useState: <T>(initState: T) => [T, Dispatch<SetStateAction<T>>];
export declare const useReducer: <S, A>(reducer?: Reducer<S, A>, initState?: S) => [S, Dispatch<A>];
export declare const useEffect: (cb: EffectCallback, deps?: DependencyList) => void;
export declare const useLayout: (cb: EffectCallback, deps?: DependencyList) => void;
export declare const useMemo: <S = Function>(cb: () => S, deps?: DependencyList) => S;
export declare const useCallback: <T extends (...args: any[]) => void>(cb: T, deps?: DependencyList) => T;
export declare const useRef: <T>(current: T) => RefObject<T>;
export declare const getHook: <S = Function, Dependency = any>(cursor: number) => [[S, Dependency], IFiber<any>];
export type ContextType<T> = {
    ({ value, children }: {
        value: T;
        children: FreNode;
    }): FreNode;
    initialValue: T;
};
export declare const createContext: <T>(initialValue: T) => ContextType<T>;
export declare const useContext: <T>(contextType: ContextType<T>) => T;
export declare const isChanged: (a: DependencyList, b: DependencyList) => boolean;
